;ToDo:
;- mereni baterii za provozu
;- lepsi vyuziti signalizacnich LED a buzzeru
;- pri detekci prekazky obema senzory
;  se vzdy toci na jednu stranu. Bylo by dobre
;  tam dat nahodne rozhodnuti nebo si pamatovat
;  posledni toceni. Ono to je take tim, ze se
;  kontroluje jako prvni jeden ze senzoru, tim
;  je dana priorita tohoto smeru...
;o zkontrolovat delku pulsu pro oba smery
;  detekce - aby byla dodrzena stejna citlivost
;  pro oba smery
;- zrychlit spusteni pri ladeni, napr. D=1 apod.
;o zrychlit casove kriticke casti precislovanim
;o zrychlit detekci po kontrole osciloskopem
;- pokud se resi jeden vstup senzoru,
;  nekontrolujou se dalsi! pri vyhybani se prekazce
;  muze spadnout ze stolu apod.
;x doplnit zadni cidla okraje!!!
;- zmenou citlivosti udrzovat odstup od cile
;  v rezimu sledovani
;- dodelat nahodne hledani cile: chvili se tocit, pak popojet
;============
;PicPuter HW:
;------------
;RA4 - RTS
;RC0 - CTS
;RC1 - USAGE LED
;RC2 - LCD contrast
;RC6 - TxD
;RC7 - RxD
;------------
;MiniSumo HW:
;------------
;RA0 - sensor0 in levy
;RA1 - sensor1 in
;RA2 - sensor2 in pravy
;RB0 - SHF signal
;RB1 - BUZZER
;RB2 - LED2 green
;RB3 - LED1 yellow
;RB4 - PWMdir1
;RB5 - PWMdir2
;RB6 - PWMdir3
;RC2 - PWM out
;RD0 - SW.1
;RD1 - SW.2
;RD2 - SW.3
;RD3 - SW.4
;RD4 - OUT0 - prave vzad
;RD5 - OUT1 - leve vpred
;RD6 - OUT2 - leve vzad
;RD7 - OUT3 - prave vpred
;RE0 - sensor out 2
;RE1 - sensor out 1
;RE2 - START
;------------
;7654
;1111 all STOP
;0000 all STOP
;0xx1 pravy vpred
;1xx0 pravy vzad
;x01x levy vzad
;x10x levy vpred
;========
;promenne
;A - temp
;L - pocet otoceni doleva
;P - pocet otoceni na jednu stranu, pokud je detekovan roh
;R - pocet otoceni doprava
;S - stav senzoru
;D - PWMdir maska
;U - napeti po zapnuti
;========
;automaticke spusteni po zapnuti/resetu
0 GOTO  10
;--------
;----- rychle spusteni z prikazove radky
;inicializace HW a promennych
1 GOSUB 20
;spusteni vybrane ulohy
2 GOTO 70
;--------
;----- standardni spusteni s cekanim na tlacitko
;inicializace HW a promennych
10 GOSUB 20
;cekani na stisk tlacitka
11 GOSUB 300
;spusteni vybrane ulohy
12 GOTO 70
;----- zakladni obecne parametry
;rychlost leveho kola
20 W = 31
;rychlost praveho kola
21 V = 30
;zakladni intenzita detekce prekazky - max 62
22 I = 3
;maska pouzitych vstupu
23 M = $FFFF
;inicializce portu a promennych
30 GOSUB 200
;kontrola stavu akumulatoru
31 GOTO 280
;--------
;nacteni stavu DIPsw
75 A = PORTD and $000F
76 A = A xor $000F
77 PRINT "TASK "
78 PRINT A CRLF
79 GOTO 80 + A
;jednotlive volby DIPsw
;80-95
;0-7: ladici funkce
;vypisovani stavu senzoru na terminal
87 GOTO 350
;8-15: rezimy cinnosti
;uklizeni stolu (hledani a likvidace cile)
91 GOTO 700
;rezim vyhybani prekazkam
95 GOTO 800
;========
;podprogramy
;--------
;---- cteni senzoru
;RB4:RB5:RB6
;$4210 left
;$2108 right
;RE0:RE1
;$0084 left
;$0042 middle
;$0021 right
;----
100 S = $0000
;vyber prvni sady vstupu
101 D = $0010
102 GOSUB 140
;vyber druhe sady vstupu
103 ADCON1 = $0086
104 SETB PORTE, 0
105 D = $0020
106 GOSUB 140
107 CLRB PORTE, 0
;vyber treti sady vstupu
108 SETB PORTE, 1
109 D = $0040
110 GOSUB 140
111 CLRB PORTE, 1
112 ADCON1 = $0082
;maskovani vstupu
113 S = S AND M
;114 HPRINT S CRLF
;kontrola tlacitka
115 IF PORTE AND $0004 RETURN
;ukonceni programu
137 PRINT "Exit." CRLF
138 GOSUB 900
139 END
;----
;cteni vybrane sady vstupu
140 S = S << 5
;cteni PWM signalu jedne polarity
141 CCPR1L = I
142 PORTB = PORTB or $0070
143 TRISB = TRISB xor D
;celkova doba mereni pro 0-0: 480us
;bez FOR-NEXT je doba mereni: 300us
;minimalni delka pulsu je 166us-333us!!!
144 FOR A = 0 TO 0
145 NEXT A
146 IF PORTB and $0001 GOTO 148
147 S = S or $0008
;cteni PWM signalu druhe polarity
148 TRISB = TRISB or $0070
149 CCPR1L = 128 - I
150 PORTB = PORTB and $008F
151 TRISB = TRISB xor D
152 FOR A = 0 TO 0
153 NEXT A
154 IF PORTB and $0001 GOTO 156
155 S = S or $0010
156 TRISB = TRISB or $0070
;cteni stavovych vstupu
157 A = PORTA and $0007
158 S = S or A
159 RETURN
;--------
;---- inicializace portu a promennych
201 PORTA = $0000
202 PORTB = $0000
203 PORTC = $00C0
204 PORTD = $0000
205 PORTE = $0000
211 TRISA = $00FF
212 TRISB = $0071
213 TRISC = $0080
214 TRISD = $000F
215 TRISE = $0004
;flash signed, ADC, Stepper+PWM, RANDOM, RTC
219 CONFIGURATOR = $100F
;software PWM settings
220 PW0 = 0
221 PW1 = 0
222 PW2 = 0
223 PW3 = 0
224 PP0 = 128
225 PP1 = 128
226 PP2 = 128
227 PP3 = 128
;hardware PWM settings
;CCP1 PWM mode
230 CCP1CON = $000F
;TMR2 pre 1:1 post 1:3
231 T2CON = $0014
;18.432MHz / 4 / 128 = 36kHz
232 PR2 = 127
234 CCPR1L = 63
;right justified, Ain0..Ain4 enabled
235 ADCON1 = $0082
249 RETURN
;right justified, all digital inputs
;250 ADCON1 = $0086
;--------
;---- kontrola stavu akumulatoru
;Buzzer, 2xLED on as load
280 PORTB = PORTB OR $000E
281 PAUSE 100 HUND
282 PORTB = PORTB AND $00F5
290 PRINT "Uaku="
291 U = ADC3 .* $0284
292 FPRINT U
293 PRINT "V - "
294 IF U < $0600 GOTO 298
295 PRINT "OK." CRLF
296 RETURN
298 PRINT "LOW!" CRLF
299 END
;--------
;---- cekani na stisk tlacitka
310 DO
311 PAUSE 5 HUND
312 SETB PORTB , 3
313 PAUSE 5 HUND
314 CLRB PORTB , 3
315 A = PORTE AND $0004
316 WHILE A
317 SETB PORTB , 3
318 PAUSE 200 HUND
319 A = PORTE AND $0004
320 CLRB PORTB , 3
321 IF A GOTO 325
322 PRINT "Exit." CRLF
323 END
325 PAUSE 300 HUND
326 RETURN
;========
;---- vypisovani stavu senzoru na terminal
350 I = 2
370 SETB PORTB, 3
371 GOSUB 100
372 CLRB PORTB, 3
373 HPRINT S CRLF
374 PAUSE 50 HUND
375 GOTO 370
;========
;---- uklizeni stolu (hledani a likvidace cile)
;otacim se urcitou chvili dokola a hledam cil
; globalni promenna urcuje, kolikrat to zkousim
;pokud cil nenajdu zkusim (nahodne) popojet
; a jdu zas od zacatku
;dokud mam cil, jedu az na kraj
;je otazka, zda detekuju cil, kdyz jsem nadoraz...
; mozna by pomohlo zvysit vykon vysilace??
700 GOSUB 790
;hledani cile: 950 nebo 970
701 GOSUB 950
702 GOSUB 100
703 IF S == $0000 GOTO 702
704 GOSUB 900
;kontrola cidel
;kontrola detekce rohu
713 IF P == 0 GOTO 716
714 P = P - 1
715 GOTO 730
;cidla okraje
716 IF S AND $0021 GOTO 740
717 IF S AND $0084 GOTO 730
;sledovani cile
718 IF S GOTO 760
720 GOTO 701
;--- detekce praveho kraje
730 IF R <= L GOTO 733
731 R = 0
732 L = 0
733 R = L + 1
734 IF R > Q GOTO 750
;pravy vzad
735 GOSUB 910
736 GOSUB 100
737 IF S AND $0084 GOTO 736
738 PAUSE 50 HUND
739 GOTO 713
;--- detekce leveho kraje
740 IF L <= R GOTO 743
741 R = 0
742 L = 0
743 L = R + 1
744 IF L > Q GOTO 750
;levy vzad
745 GOSUB 930
746 GOSUB 100
747 IF S AND $0021 GOTO 746
748 PAUSE 50 HUND
749 GOTO 713
;???
750 P = 4
751 GOTO 735
;--- sledovani cile
760 GOSUB 100
761 IF S AND $00A5 GOTO 704
762 IF S AND $2108 GOTO 780
763 IF S AND $4210 GOTO 785
764 GOTO 701
;sledovani vpred
775 GOSUB 980
776 GOTO 760
;sledovani vpravo
780 IF S AND $4210 GOTO 775
781 GOSUB 960
782 GOTO 760
;sledovani vlevo
785 IF S AND $2108 GOTO 775
786 GOSUB 920
787 GOTO 760
;---- inicializace promennych
;zakladni intenzita detekce prekazky
790 I = 1
;hystereze detekce prekazky
791 H = 2
;pocet opakovani L/R pri detekci rohu (spodni senzory)
792 Q = 5
;maska pouzitych vstupu
;793 M = $03A0
793 M = $63A0
;pracovni promenne
796 R = 0
797 L = 0
798 P = 0
799 RETURN
;========
;---- novy algoritmus pro vyhybani prekazkam
800 GOSUB 890
;jizda vpred
801 I = I + H
802 I = I - H
803 GOSUB 980
804 GOSUB 100
805 IF S == $0000 GOTO 804
;pro kontrolu jeste jeden test
806 GOSUB 100
807 IF S == $0000 GOTO 804
;vyssi intenzita detekce pro vyhybani
808 I = I + H
;stop
809 GOSUB 900
;810 PAUSE 10 HUND
811 GOSUB 100
812 IF S == $0000 GOTO 802
;kontrola detekce rohu
813 IF P == 0 GOTO 816
814 P = P - 1
815 GOTO 830
;kontrola cidel
;cidla okraje
816 IF S AND $0021 GOTO 840
817 IF S AND $0084 GOTO 830
;cidla prekazky
818 IF S AND $2108 GOTO 860
819 IF S AND $4210 GOTO 870
820 GOTO 804
;--- detekce praveho kraje
830 IF R <= L GOTO 833
831 R = 0
832 L = 0
833 R = L + 1
834 IF R > Q GOTO 850
;pravy vzad
835 GOSUB 910
836 GOSUB 100
837 IF S AND $0084 GOTO 836
838 PAUSE 50 HUND
839 GOTO 809
;--- detekce leveho kraje
840 IF L <= R GOTO 843
841 R = 0
842 L = 0
843 L = R + 1
844 IF L > Q GOTO 850
;levy vzad
845 GOSUB 930
846 GOSUB 100
847 IF S AND $0021 GOTO 846
848 PAUSE 50 HUND
849 GOTO 809
;???
850 P = 4
851 GOTO 835
;--- detekce prave prekazky
;toceni na miste vlevo
860 GOSUB 950
861 GOSUB 100
862 IF S AND $00C5 GOTO 816
863 IF S GOTO 861
864 PAUSE 1 HUND
865 GOTO 809
;--- detekce leve prekazky
;toceni na miste pravo
870 GOSUB 970
871 GOTO 861
;---- inicializace promennych
;zakladni intenzita detekce prekazky
890 I = 1
;hystereze detekce prekazky
891 H = 2
;pocet opakovani L/R pri detekci rohu (spodni senzory)
892 Q = 5
;maska pouzitych vstupu
;893 M = $03A0
893 M = $63A0
;pracovni promenne
896 R = 0
897 L = 0
898 P = 0
899 RETURN
;========
;---- rizeni smeru motoru
; (skace se GOSUB 900+D)
;0      STOP
;10     PRAVY VZAD
;20     PRAVY VPRED
;30     LEVY VZAD
;60     LEVY VPRED
;------------
900 PW0 = 0
901 PW1 = 0
902 PW2 = 0
903 PW3 = 0
904 RETURN
;------------
910 PW0 = 0
911 PW1 = 0
912 PW2 = 0
913 PW3 = V
914 RETURN
;------------
920 PW1 = 0
921 PW2 = 0
922 PW3 = 0
923 PW0 = V
924 RETURN
;------------
930 PW0 = 0
931 PW2 = 0
932 PW3 = 0
933 PW1 = W
934 RETURN
;------------
940 PW0 = 0
941 PW2 = 0
942 PW1 = W
943 PW3 = V
944 RETURN
;------------
950 PW2 = 0
951 PW3 = 0
952 PW0 = V
953 PW1 = W
954 RETURN
;------------
960 PW0 = 0
961 PW1 = 0
962 PW3 = 0
963 PW2 = W
964 RETURN
;------------
970 PW0 = 0
971 PW1 = 0
972 PW2 = W
973 PW3 = V
974 RETURN
;------------
980 PW1 = 0
981 PW3 = 0
982 PW0 = V
983 PW2 = W
984 RETURN
;---- konec programu
1021 DATA 1026
